<template>
  <v-app>
    <v-snackbar
        top
        v-model="msg"
        color="red"
    >
      {{ msgTxt }}
      <template v-slot:action="{ attrs }">
        <v-btn
            color="black"
            text
            v-bind="attrs"
            @click="msg = false"
        >
          Close
        </v-btn>
      </template>
    </v-snackbar>

    <v-card v-if="isAuthenticated">
      <v-toolbar
          flat
          color="primary"
          dark
      >
        <v-btn class="mx-10 justify-end" @click="logout">logout</v-btn>
        <v-toolbar-title>ParsPack Test Project</v-toolbar-title>
      </v-toolbar>
      <v-tabs vertical>
        <v-tab @click="getFiles">
          Files
          <v-icon left>
            mdi-file
          </v-icon>
        </v-tab>
        <v-tab @click="getDirectories">
          Directories
          <v-icon left>
            mdi-folder
          </v-icon>
        </v-tab>
        <v-tab>
          Process Monitoring
          <v-icon left>
            mdi-eye
          </v-icon>
        </v-tab>

        <v-tab-item>
          <v-card flat>
            <v-card-text>
              <v-banner v-for="file in files" :key="file">
                {{ file }}
              </v-banner>
              <v-row>
                <v-col cols="6" class="justify-center">
                  <v-text-field
                      v-model="fileName"
                      label="File name"
                  ></v-text-field>
                  <v-text-field
                      v-model="extension"
                      label="extension"
                  ></v-text-field>
                  <v-btn @click="createFile">Create</v-btn>
                </v-col>
              </v-row>
            </v-card-text>
          </v-card>
        </v-tab-item>
        <v-tab-item>
          <v-card flat>
            <v-card-text>
              <v-banner v-for="directory in directories" :key="directory">
                {{ directory }}
              </v-banner>
              <v-row>
                <v-col cols="8" class="justify-center">
                  <v-text-field
                      v-model="directoryName"
                      label="Directory name"
                  ></v-text-field>
                  <v-btn @click="createDirectory">Create</v-btn>
                </v-col>
              </v-row>
            </v-card-text>
          </v-card>
        </v-tab-item>
        <v-tab-item>
          <v-card flat>
            <v-card-text>
              <v-card
                  elevation="8"
                  color="#3dbce7"
                  width="80%"
                  style="display:table;margin:auto;"
                  class="pa-1 mt-5"
              >
                <p class="text-lg-center ma-10 text-md-center">
                  List of process
                </p>
                <v-row>
                  <v-col class="col-lg-3 col-md-4 col-sm-12" v-for="work in processData" :key="work">
                    <v-banner>
                      {{ work }}
                    </v-banner>
                  </v-col>
                </v-row>
                <v-row>
                  <v-col cols="12">
                    <p style="font-weight: 800">Enter Flag like as example</p>
                    <p>-A : View all the running processes</p>
                    <p>-a : View all processes except those that fulfill the specified conditions</p>
                    <p>-d : View all the processes except session leaders</p>
                    <p>-T : View all processes associated with this terminal</p>
                    <p>-r : View all the running processes</p>
                    <p>-x : View all processes owned by you</p>
                    <v-text-field v-model="flag" label="ps "></v-text-field>
                    <v-btn @click="exec">Send</v-btn>
                  </v-col>
                </v-row>
              </v-card>
            </v-card-text>
          </v-card>
        </v-tab-item>
      </v-tabs>
    </v-card>


    <v-card
        v-if="!isAuthenticated && RegisterTab"
        color="#dadada"
        width="40%"
        style="display: table;margin:auto;"
        class="pa-5 mt-16">
      <v-btn
          style="display: table;margin:auto;"
          color="light" disabled>
        ParsPack Process Manager
      </v-btn>
      <v-row>
        <v-col cols="12">
          <v-text-field
              v-model="credentials.name"
              :rules="nameRules"
              label="Name"
          ></v-text-field>
        </v-col>
        <v-col cols="12">
          <v-text-field
              v-model="credentials.email"
              :rules="emailRules"
              label="Email"
          ></v-text-field>
        </v-col>
        <v-col cols="12">
          <v-text-field
              v-model="credentials.password"
              :rules="passwordRules"
              label="Password"
              counter="32"
          ></v-text-field>
        </v-col>
        <v-col cols="12">
          <v-text-field
              v-model="credentials.password_confirmation"
              :rules="passwordRules"
              label="Password Confirmation"
              counter="32"
          ></v-text-field>
        </v-col>
      </v-row>
      <v-btn @click="register()" class="my-8" color="success" style="display: table;margin:auto;">
        Register
      </v-btn>
    </v-card>

    <v-card
        v-if="!isAuthenticated && showLoginForm"
        color="#dadada"
        width="40%"
        style="display: table;margin:auto;"
        class="pa-5 mt-16">
      <v-row>
        <v-col cols="12">
          <v-text-field
              v-model="credentials.email"
              :rules="emailRules"
              label="Email"
          ></v-text-field>
        </v-col>
        <v-col cols="12">
          <v-text-field
              v-model="credentials.password"
              :rules="passwordRules"
              label="Password"
              counter="32"
          ></v-text-field>
        </v-col>
      </v-row>
      <v-btn @click="login()" class="my-8" color="success" style="display: table;margin:auto;">
        Login
      </v-btn>
      <v-btn color="blue" @click="RegisterTab=true">Create an account</v-btn>
    </v-card>
  </v-app>
</template>

<script>

export default {
  name: 'App',
  data: () => ({
    RegisterTab: false,
    msg: false,
    msgTxt: '',
    flag: '',
    fileName: '',
    extension: '',
    directoryName: '',
    processData: [],
    files: [],
    directories: [],
    showLoginForm: false,
    isAuthenticated: false,
    credentials: {
      name: null,
      password_confirmation: null,
      email: null,
      password: null,
    },
    emailRules: [
      value => !!value || 'Required.',
      value => (value || '').length <= 40 || 'Max 40 characters',
      value => {
        const pattern = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/
        return pattern.test(value) || 'Invalid e-mail.'
      },
    ],
    passwordRules: [
      value => !!value || 'Required.',
      value => (value || '').length <= 32 || 'Max 32 characters',
    ],
    nameRules: [
      value => !!value || 'Required.',
      value => (value || '').length <= 50 || 'Max 50 characters',
    ],
  }),
  beforeMount() {
    window.axios.get('/user').then(() => {
      this.isAuthenticated = true
      window.axios.get('/process').then((response) => {
        this.processData = response.data.data
        this.showProcess = true
      })
    }).catch(() => {
      this.showLoginForm = true
    })
    window.axios.get('directory').then((res) => {
      this.directories = res.data.data
    })
    window.axios.get('file').then((res) => {
      this.files = res.data.data
    })
  }
  ,
  methods: {
    register() {
      window.axios.post('/v1/register', {
        name: this.credentials.name,
        email: this.credentials.email,
        password: this.credentials.password,
        password_confirmation: this.credentials.password_confirmation,
      }).then(() => {
        this.isAuthenticated = true
        this.RegisterTab = false
        this.showProcess = true
        window.axios.get('/process').then((response) => {
          this.processData = response.data.data
        })
      }).catch((error) => {
        console.log(error)
        this.msgTxt = 'please check your inputs'
        this.msg = true
      });
    }
    ,
    login() {
      window.axios.post('/v1/login', {
        email: this.credentials.email,
        password: this.credentials.password,
      }).then(() => {
        this.isAuthenticated = true
        this.showProcess = true
        window.axios.get('/process').then((response) => {
          this.processData = response.data.data
        })
      }).catch(() => {
        this.msgTxt = 'These credentials do not match our records.Please check inputs'
        this.msg = true
      });
    }
    ,
    logout() {
      window.axios.get('/v1/logout').then(() => {
        this.isAuthenticated = false
        this.showLoginForm = true
      })
    }
    ,
    exec() {
      window.axios.get('/process?flag=' + this.flag).then((res) => {
        this.processData = res.data.data
      })
    }
    ,
    getDirectories() {
      window.axios.get('directory').then((res) => {
        this.directories = res.data.data
      })
    }
    ,
    getFiles() {
      window.axios.get('file').then((res) => {
        this.files = res.data.data
      })
    }
    ,
    createDirectory() {
      window.axios.post('directory', {
        name: this.directoryName,
      }).then(() =>
          window.axios.get('directory').then((res) => {
            this.directories = res.data.data
          })
      )
    }
    ,
    createFile() {
      window.axios.post('file', {
        filename: this.fileName,
        extension: this.extension
      }).then(() =>
          window.axios.get('file').then((res) => {
            this.files = res.data.data
          })
      )
    }
  }
}
</script>
